
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "rif_f.h"

extern void	Error(char *msg);

int	main(int argc,char **argv)
{
	int	Nx,Ny,y0,Y,ny,dz,y1,y2,y,x,Dz;
	FOM	**fom,f;
	FILE	*file;
	double	a,s2,b,s1,rmv,RMV;

	if (argc<2 || argc>5) Error("usage : ta_dz TA.tif {y1 y2} {SVC.txt}");

	if (ReadImageFile_Float(argv[1],&Nx,&Ny,&fom,NULL))
	    (void)fputs("integer TIFF (warning).\n",stderr);

	if (Nx<2) Error("too few views.");

	if (argc==2 || argc==3) {
	    y0=0; Y=ny=Ny;
	}
	else
	    if ((y0=atoi(argv[2]))<0 ||
		(Y=atoi(argv[3])+1)>Ny ||
		(ny=Y-y0)<=0) Error("bad slice range.");

	if (argc==2 || argc==4)
	    file=NULL;
	else
	    if (argv[argc-1][0]=='-')
		file=stdout;
	    else
	    if ((file=fopen(argv[argc-1],"w"))==NULL) Error("file not open.");

	for (dz=1-ny; dz<ny; dz++) {
	    if (dz<0) {
		y1=y0; y2=Y+dz;
	    }
	    else {
		y1=y0+dz; y2=Y;
	    }
	    a=(double)dz/(double)(Nx-1); s2=0.0;
	    for (y=y1; y<y2; y++) {
		b=(double)y+0.5; s1=0.0;
		for (x=0; x<Nx; x++) {
		    f=fom[(int)floor(b-a*(double)x)][x]; s1+=f; s2+=(f*f);
		}
		s2-=(s1*s1/(double)Nx);
	    }
	    rmv=sqrt(s2/(double)Nx/(double)(y2-y1));
	    if (dz==1-ny || rmv<RMV) {
		Dz=dz; RMV=rmv;
	    }
	    if (file!=NULL) (void)fprintf(file,"%d\t%lf\n",dz,rmv);
	}
	if (file!=NULL && file!=stdout) (void)fclose(file);

	(void)printf("%d\t%le\n",Dz,RMV);

	for (y=Ny-1; y>=0; y--) free(fom[y]); free(fom);

	return 0;
}
